
package org.test.comp;

import org.test.comp.gui.IGlobalSwingFrame;

import com.sun.star.document.EventObject;
import com.sun.star.document.XEventListener;
import com.sun.star.frame.XModel;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XComponentContext;

public class OODocumentEventListener implements XEventListener {

    private IGlobalSwingFrame frame = null;

    public OODocumentEventListener(XComponentContext xComponentContext,
            IGlobalSwingFrame frame) {
        this.frame = frame;
    }

    public void notifyEvent(EventObject evt) {

        if (evt == null)
            return;

        frame.displayMessage("doc: " + evt.EventName);

        if (evt.EventName.equals("OnUnload")) {
            XModel xModel = (XModel) UnoRuntime.queryInterface(XModel.class,
                    evt.Source);
            if (xModel != null) {
                xModel.removeEventListener(this);
                frame.displayMessage("doc: listener removed ...");
            } else
                frame.displayMessage("doc: error removing listener ...");
        }
    }

    public void disposing(com.sun.star.lang.EventObject evt) {
        frame.displayMessage("doc: disposing ...");
    }
}
