
package org.test.comp;

import org.test.XGetSomething;
import org.test.comp.gui.GlobalSwingFrame;

import com.sun.star.beans.NamedValue;
import com.sun.star.document.XEventBroadcaster;
import com.sun.star.lang.XMultiComponentFactory;
import com.sun.star.lang.XServiceInfo;
import com.sun.star.lib.uno.helper.ComponentBase;
import com.sun.star.task.XJob;
import com.sun.star.task.XJobExecutor;
import com.sun.star.uno.Exception;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XComponentContext;

public class OOGlobalEventConfigurator extends ComponentBase implements
        XServiceInfo, XJobExecutor, XJob, XGetSomething {

    static final String __serviceName = "org.test.OOGlobalEventConfigurator";

    private XComponentContext xComponentContext = null;
    private XEventBroadcaster xEvtBroadcast = null;

    public OOGlobalEventConfigurator(XComponentContext xComponentContext) {
        this.xComponentContext = xComponentContext;
    }

    private void configure() {

        if (xEvtBroadcast != null)
            return;

        try {
            XMultiComponentFactory xMultiComponentFactory = xComponentContext
                    .getServiceManager();

            Object objBroadCast = xMultiComponentFactory
                    .createInstanceWithContext(
                            "com.sun.star.frame.GlobalEventBroadcaster",
                            xComponentContext);

            xEvtBroadcast = (XEventBroadcaster) UnoRuntime.queryInterface(
                    XEventBroadcaster.class, objBroadCast);

            OOGlobalEventListener oBroadCast = new OOGlobalEventListener(
                    xComponentContext, new GlobalSwingFrame(xComponentContext));

            xEvtBroadcast.addEventListener(oBroadCast);

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public String getImplementationName() {
        return getClass().getName();
    }

    public boolean supportsService(String name) {
        if (name.equals(__serviceName))
            return true;
        return false;
    }

    public String[] getSupportedServiceNames() {
        String[] retValue = new String[0];
        retValue[0] = __serviceName;
        return retValue;
    }

    // XJob (used for calls via event/ui)
    public Object execute(NamedValue[] args) {
        configure();
        return null;
    }

    // XJobExecutor (used for calls from basic ...)
    public void trigger(String sEvent) {
        configure();
    }

    // XGetSomething 
    public String saySomething(String _something) {
        return _something;
    }
}
